﻿<?php
	
	// Добавление корневой категории
	$this->db->query("INSERT INTO `{#}forum_cats` (`id`, `parent_id`, `title`, `description`, `slug`, `slug_key`, `seo_title`,
	`seo_keys`, `seo_desc`, `is_pub`, `as_folder`, `ns_left`, `ns_right`, `ns_level`, `ns_ignore`, `ns_differ`, `ordering`,
	`icon`, `topic_cost`, `threads_count`, `posts_count`, `last_post`, `moderators`, `allow_read`, `allow_add`) VALUES
	(1, 0, 'Корневой раздел', '', 'all', NULL, '', '', '', 1, 1, 1, 2, 1, 0, '', 1, '', 0, 0, 0, NULL, NULL, NULL, NULL)");
	
	
	$sql = $this->selectold('forum_cats', 'id > 1'); // Выборка из таблицы категорий
	
	foreach($sql as $res){ // Перебор массива данных из источника
		
		$res['seolink'] = $res['id'].'-'.$res['seolink']; // Генерация урла
		
		$cat_forum = array(
		
		'id' => $res['id'],
		'title' => $res['title'],
		'slug' => $res['seolink'],
		'ordering' => $res['ordering'],
		'as_folder' => '1',
		'parent_id' => '1',
		);
		// Добавляем категорию, используя родную функцию Инстанта
		$this->addCatmigrate('forum_cats', $cat_forum);
		$this->update('forum_cats', $res['id'], $cat_forum);
	}
	
	// Получаем дочерние категории форума
	$sql = $this->selectold('forums', 'id > 1' );
	
	// Перебор категорий форума
	foreach($sql as $res){
		
		// Если корневая категория нулевая - используем категорию форумов в качестве родительской категории
		if ($res['parent_id'] == 1000){$res['parent_id'] = $res['category_id'];}
		
		// slug из тайтла и ид
		$category_slug = $res['id'].'-'.lang_slug($res['title']); 
		
		// Если что-то есть в поле последнего сообщения, формируем поле last_msg
		if (strlen($res['last_msg']) > 10){
			
			$last_p = cmsModel::yamlToArray($res['last_msg']);
			
			$poid = $last_p['id'];
			
			$puid = $this->db->getRow('forum_posts', "id = $poid");
			
			$uid = $puid['user_id'];
			
			$lp = array(
			'post_id' => $last_p['id'],
			'date_pub' => $last_p['pubdate'],
			'user_id' => $uid,
			'user_nickname' => $last_p['author_nickname'],
			'thread_title' => $last_p['thread_title']
			);
			
		} else {$lp = '';} // Если нет - значит нет
		
		$forum_cats = array(
		'id' => $res['id'],
		'parent_id' => $res['category_id'],
		'title' => $res['title'],
		'description' => $res['description'],
		'slug' => $category_slug,
		'is_pub' => $res['published'],
		'ordering' => $res['ordering'],
		'icon' => $res['icon'],
		'topic_cost' => $res['topic_cost'],
		'threads_count' => $res['thread_count'],
		'posts_count' => $res['post_count'],
		'last_post' => $lp,
		'moderators' => $res['moder_list'],
		'allow_read' => $res['access_list'],
		'allow_add' => $res['access_list']
		);
		
		// Добавляем категории форума, используя родную функцию Инстанта
		$this->addCatmigrate('forum_cats', $forum_cats);
		$this->update('forum_cats', $res['id'], $forum_cats);
		unset ($lp);
	}
	
	$sql = $this->selectold('forum_threads' ); // Получаем массив с темами форума
	
	
	foreach($sql as $res){ // Формируем ассив для вставки в категории форума
		
		$thread_slug = "t{$res['id']}-".lang_slug($res['title']); // Генерируем ссылку на тему
		
		if (strlen($res['last_msg']) >10){ // Если что-то есть в последних темах - формируем поле
			
			$last_p = cmsModel::yamlToArray($res['last_msg']);  // Из ямла преобразуем последние темы в массив
			
			$poid = $last_p['id'];
			
			$puid = $this->db->getRow('forum_posts', "id = $poid"); // Получаем массив поста форума по id
			
			$uid = $puid['user_id']; // Пользователя этого поста получаем
			
			// Массив для вставки в поле последнео сообщения
			$lp = array(
			'post_id' => $last_p['id'],
			'date_pub' => $last_p['pubdate'],
			'user_id' => $uid,
			'user_nickname' => $last_p['author_nickname'],
			'thread_title' => $last_p['thread_title']
			);
			
		} else {$lp = '';} // Нечего вставлять - значит вставляем пустое место
		
		// Массив для вставки в темы форума
		$forum_threads = array(
		'id' => $res['id'],
		'user_id' => $res['user_id'],
		'category_id' => $res['forum_id'],
		'title' => $res['title'],
		'slug' => $thread_slug,
		'description' => $res['description'],
		'date_pub' => $res['pubdate'],
		'is_fixed' => $res['pinned'],
		'is_closed' => $res['closed'],
		'is_pinned' => $res['pinned'],
		'hits' => $res['hits'],
		'posts_count' => $res['post_count'] ,
		'last_post' => $lp 
		);
		
		// Вставляем темы в форум
		$this->db->insert('forum_threads', $forum_threads, true);
		
		
		unset ($lp); // Удаляем массив с последними темами
	}
	
	$sql = $this->selectold('forum_polls' );  // Получеем массив с голосованиями на форуме
	
	// Перебор массива голосований
	foreach($sql as $res){
		
		$polls = array(
		'id' => $res['id'],
		'thread_id' => $res['thread_id'],
		'title' => $res['title'],
		'description' => $res['description'],
		'options' => $res['options'],
		'answers' => $res['answers'],
		'date_pub_end' => $res['enddate']
		);
		$this->db->insert('forum_polls', $polls, true);
	}
	
	$this->tagsReplace('forum_posts');
	$this->tagsReplace('forum_posts', 'content_html');
	
	$num_threads = $this->db->getRowsCount('forum_threads');
	
	$num = $this->db->getRowsCount('forum_posts');
	
	echo 'Миграция форумов завершена. <br/>Количество тем форума  =  '.$num_threads;
	
	echo '<br/>Количество постов в таблице  =  '.$num;
	
	$runtime = microtime(true) - $start;
	
	$this->runtime($runtime);
	
	
	
?>