﻿<?php
	
	//-----------------------------------------------------------------------------------------------------//
	// ПЕРЕНОС КЛУБОВ
	//-----------------------------------------------------------------------------------------------------//
	
	$start = microtime(true);	
	
	echo "Таблицы источника - {$pref}clubs";
	
	$this->db->query('TRUNCATE {#}groups'); // Очищаем таблицу перед миграцией
	
	echo ", {$pref}user_clubs  ";
	
	$this->db->query('TRUNCATE {#}groups '); // Очищаем таблицу перед миграцией
	
	$this->db->query('TRUNCATE {#}groups_members'); // Очищаем таблицу перед миграцией
	
	$gru = $this->selectold('clubs'); // Выборка из таблицы источника
	
	// Перебор массива данных, полученных из источника
	foreach($gru as $res){
		
		// Нет данных - пишем ноль
		if (empty($res['members_count'])){$res['members_count'] = 0;}
		$imageurl = array(
		'original' => "old/clubs/{$res['imageurl']}",
		'big' => "old/clubs/{$res['imageurl']}",
		'normal' => "old/clubs/{$res['imageurl']}",
		'micro' => "old/clubs/{$res['imageurl']}",
		'small' => "old/clubs/{$res['imageurl']}"
		);
		$res['imageurl'] = cmsModel::arrayToYaml($imageurl);
		
		// Формируем массив для записи в новую базу
		$group = array(
		'id' => $res['id'],
		'owner_id' => $res['admin_id'], 
		'date_pub' => $res['pubdate'], 
		'title' => $res['title'], 
		'description' => $res['description'], 
		'logo' => $res['imageurl'], 
		'rating' => $res['rating'], 
		'members_count' => $res['members_count'], 
		'join_policy' => $res['join_karma_limit'] 
		);
		
		$this->db->insert('groups', $group); // Записываем массив в новую базу
		
	}
	
	// Выборка клубов из таблицы источника
	$grm = $this->selectold('user_clubs');
	
	// Перебор массива данных, полученных из источника
	foreach ($grm as $res){
		
		// Назначаем роли в клубах (1 - пользователь, 2 - модератор)
		if ($res['role'] == 'member'){$role = '1';} else {$role = '2';} 
	
	// Формируем массив для записи в новую базу
	$group_members = array(
	
	'group_id' => $res['club_id'], 
	'user_id' => $res['user_id'], 
	'role' => $role,
	'date_updated' => $res['pubdate'] 
	);
	$this->db->insert('groups_members', $group_members); // Записываем массив в новую базу
	}

	
	$num = $this->db->getRowsCount('groups'); // Подсчет числа групп
	
	echo '<br/>Миграция клубов завершена.<br/> Количество записей в таблице groups =  '.$num;
	
	$runtime = microtime(true) - $start; // Вычисление времени работы скрипта
	
	$this->runtime($runtime); // Отображение времени работы скрипта
	
	
	
	?>	