﻿<?php
	
	//-----------------------------------------------------------------------------------------------------//
	// ПЕРЕНОС ФОТОАЛЬБОМОВ
	//-----------------------------------------------------------------------------------------------------//   
	
	$start = microtime(true);
	
	echo "Таблица источника - {$pref}photo_albums  ";
	
	$this->db->query('TRUNCATE {#}con_albums');
	
	$this->db->query('TRUNCATE {#}photos');
	
	$sql = $this->selectold('photo_albums', 'id <> 100');
	
	foreach($sql as $res){
	
	$cover_sql = $this->selectold('photo_files', "album_id = {$res['id']}", 'ORDER BY id DESC LIMIT 1' );
	$cover = "---
original: old/photos/medium/{$cover_sql[0]['file']}
big: old/photos/medium/{$cover_sql[0]['file']}
normal: old/photos/medium/{$cover_sql[0]['file']}
small: old/photos/small/{$cover_sql[0]['file']}";
		
		$album_slug = $res['id'].'-'.lang_slug($res['title']);
		
		$counter = $this->counter('photo_files', "album_id = {$res['id']}");
		
		$album = array(
		'id' => $res['id'],
		'title' => $res['title'],
		'content' => $res['description'],
		'slug' => $album_slug,
		'tags' => $res['showtags'],
		'date_pub' => $res['pubdate'],
		'date_last_modified' => $res['pubdate'],
		'is_pub' => $res['published'],
		'user_id' => $res['user_id'],
		'parent_id' => $res['parent_id'],
		'category_id' => '1',
		'photos_count' => $counter,
		'is_comments_on' => $res['is_comments'],
		'is_approved' => '1',
		'date_approved' => $res['pubdate'],
		'cover_image' => $cover,
		'is_public' => '1'
		);
		
		$this->db->insert('con_albums', $album);
	}
	unset ($sql);
	

	
	$sql = $this->selectold('photo_files');
	
	foreach($sql as $res){
		
		$photo_slug = $res['id'].'-'.lang_slug($res['title']);
		
		
		if ($res['file']) {
			
			$photofile = array();
			
			$photofile['original'] = 'old/photos/medium/' . $res['file'];
			$photofile['big'] = 'old/photos/medium/' . $res['file'];
			$photofile['normal'] = 'old/photos/medium/' . $res['file'];
			$photofile['small'] = 'old/photos/small/' . $res['file'];
			$res['file'] = cmsModel::arrayToYaml($photofile);
			} else {
			$res['file'] = '';
		}
		
		if (empty($res['rating'])){$res['rating'] = 0;}
		
		$photos = array(
		'id' => $res['id'],
		'album_id' => $res['album_id'],
		'user_id' => $res['user_id'],
		'date_pub' => $res['pubdate'],
		'date_photo' => $res['pubdate'],
		'title' => $res['title'],
		'sizes' => '---
original:
  width: 500
  height: 500
big:
  width: 500
  height: 500
normal:
  width: 250
  height: 250
small:
  width: 64
  height: 64',
		'image' => $res['file'],
		'rating' => $res['rating'],
		'comments' => $res['comments'],
		'hits_count' => $res['hits'],
		'slug' => $photo_slug
		);
		
		$this->db->insert('photos', $photos);
	}
	
	$num = $this->db->getRowsCount('photos');
	
	echo '<br/>Миграция альбомов и фото завершена.<br/> 
	
	Количество записей в таблице photos =  '.$num;
	
	$runtime = microtime(true) - $start;
	
	$this->runtime($runtime);       
	
	
?>