﻿<?php
	
	// Создаем корневую категорию в постах
	$this->db->nestedSets->setTable('con_'.$posts.'_cats');
	$this->db->nestedSets->addRootNode();
	
	// Создаем корневую категорию в блогах
	$this->db->nestedSets->setTable('con_blogs_cats');
	$this->db->nestedSets->addRootNode();
	
	// Формируем массив имени типа контента для функции вставки 
	$ctype = array(); $ctype['name'] = 'blogs'; 
	
	// Формируем массив полей для функции вставки 
	$fields = cmsCore::getModel('content')->getContentFields('blogs');
	
			// Выборка из таблицы блогов
		$blg = $this->selectold('blogs', "owner = 'user'"); 
		
		foreach ($blg as $res){
		
		$blog_slug = $res['id'].'-'.lang_slug($res['title']);
			
			// Нет метакейзов - пишем ноль
			if (isset($res['meta_desc'])){$meta_desc = $res['meta_keys'];} else {$meta_desc = 0;}
			
			$res['comments_count'] = isset($res['comments_count']) ? $res['comments_count'] : 0; // Если нет данных - записываем ноль
			
			/* $id = $res['id'] + 3000; */ // Прибавляем по 3000, чтобы не перепуталась нумерация
			
			// Формируем массив для записи в новую базу
			$blo = array(
			'id' => $res['id'],
			'title' => $res['title'],
			'slug' => $blog_slug,
			'date_pub' => $res['pubdate'],
			'is_pub' => '1',
			'user_id' => $res['user_id'],
			'category_id' => $res['ownertype'],
			'is_comments_on' => '1',
			'comments' => $res['comments_count'],
			'rating' => $res['rating'],
			'is_approved' => '1',
			'is_private' => $res['view_type']
			);
			
			cmsCore::getModel('content')->addContentItem($ctype, $blo, $fields); 	// Записываем массив категории в новую базу
		}
	
	$clubParent = $this->selectold('blogs', "owner = 'club'");
	if (!empty($clubParent)){

		
		$this->tagsReplace('con_posts'); // Правим тэги в тексте
		
		// Подсчитываем и отображаем количество перенесенных постов
		$num = $this->db->getRowsCount('con_'.$posts.'');
		
		
		echo 'Миграция блогов завершена. <br/>
		
		Количество записей в таблице con_posts =  '.$num.'.';
		
		$end = microtime(true);
		
		$runtime = $end - $start;
		
		$this->runtime($runtime); 
		
	}
	else {
	echo 'Таблица пуста';}
	
	
?>