<?php
	
	set_time_limit(10000); 
	
	
	class modelemigrator extends cmsModel {
	
		public $prefix;
		
		public $table_prefix = 'con_';
		
		public function migrate($subject, $n = 0, $start = 0) {
		
		include ('upload/old/config.php'); // Подключение в скрипт файла конфигурации
		
		require_once (__DIR__."/migrate/{$subject}.php"); // Подключение в скрипт файла миграции по имени 
		}
		
		public function migcycle($func, $n, $start){
		
		include ('upload/old/config.php'); // Подключение в скрипт файла конфигурации
		
		if (substr($func, 0, 3) == 'mig' || substr($func, 0, 3) == 'end') 
		{$subject = substr($func, 3, 12);} else {$subject = $func;} // Вычисление имени файла, который будем подключать
		
		require_once(__DIR__."/migrate/{$subject}/{$func}.php"); // Подключение в скрипт файла миграции по имени
		}

		//-----------------------------------------------------------------------------------------------------//
		// ВСПОМОГАТЕЛЬНЫЕ ФУНКЦИИ
		//-----------------------------------------------------------------------------------------------------//
		//-----------------------------------------------------------------------------------------------------//
		// ВЫБОРКА ИЗ ТАБЛИЦЫ INSTANTCMS 1.10.*
		//-----------------------------------------------------------------------------------------------------//
		public function selectold($table, $where = 1, $limit = 'ORDER BY id ASC') {
			include('upload/old/config.php'); // Подключение в скрипт файла конфигурации
			$sql = mysqli_query($link, "SELECT * FROM {$pref}$table WHERE $where  $limit")
			or die ( mysqli_error($link)); // Выборка из таблицы источника
			while ( $fetch = mysqli_fetch_assoc($sql)){
				$result[] = $fetch;	
			} // Формирование массива результата
			if (!empty($result)){
			return $result;
			}
			else {$result = null;}
		}
		

		
		//-----------------------------------------------------------------------------------------------------//
		// ПОДСЧЕТ ЗАПИСЕЙ В ТАБЛИЦЕ INSTANTCMS 1.10.*
		//-----------------------------------------------------------------------------------------------------//
		public function counter($component, $where = 1) {
			include('upload/old/config.php');
			$result = mysqli_query($link, "SELECT COUNT(*) FROM {$pref}{$component} WHERE $where");
			if ($result) {
				$row = $this->db->fetchRow($result);
				$counter = $row[0];
				$this->db->freeResult($result);
				
			}
			return $counter;
		}	
		//-----------------------------------------------------------------------------------------------------//
		// ПОДСЧЕТ ДРУЗЕЙ
		//-----------------------------------------------------------------------------------------------------//
		private function getfriendscount($user_id) {
			include('upload/old/config.php');
			
			$sql = "SELECT COUNT(1) FROM {$pref}user_friends WHERE (from_id = '$user_id' OR to_id = '$user_id') AND is_accepted =1";
			$result = mysqli_query($link, $sql);
			if ($result) {
				$row = $this->db->fetchRow($result);
				$count = $row[0];
				$this->db->freeResult($result);
				return $count;
			}
		}
		
		//-----------------------------------------------------------------------------------------------------//
		// ЗАМЕНА ЗНАЧЕНИЙ В ТАБЛИЦЕ
		//-----------------------------------------------------------------------------------------------------//	
		public function replace($table, $column, $what, $to, $where = 1) {
		
			// Замена значений в таблице. ("UPDATE где меняем SET колонка где меняем
			// = REPLACE(колонка где меняем, 'что меняем', 'на что меняем') WHERE условие ")
			$this->db->query("UPDATE {#}$table SET $column = REPLACE($column, '$what', '$to') WHERE $where ");
		}
		
		//-----------------------------------------------------------------------------------------------------//
		// ОТОБРАЖЕНИЕ ВРЕМЕНИ ВЫПОЛНЕНИЯ СКРИПТА
		//-----------------------------------------------------------------------------------------------------//	
		
		public function runtime($runtime) {
			if ($runtime >= 60)
			{echo "<br/> Скрипт выполнялся ". round($runtime / 60,  0) . " мин. ". round($runtime % 60,  0) ." сек.<br/>";}
			else {
			printf('<br/>Скрипт выполнялся %.2F сек.', $runtime);}	
			
		}
		//-----------------------------------------------------------------------------------------------------//
		// ИНСЕРТ ИГНОР
		//-----------------------------------------------------------------------------------------------------//		
		// Родная функция инстанта, но с игнором
		public function insertignore($table, $data, $skip_check_fields = false){

        if(empty($data) || !is_array($data)) { return false; }

        if(!$skip_check_fields){
            $table_fields = $this->db->getTableFields($table);
        }

        foreach ($data as $field => $value){

            if(!$skip_check_fields && !in_array($field, $table_fields)){
                continue;
            }

            $fields[] = "`$field`";
            $values[] = $this->db->prepareValue($field, $value);

        }

        $fields = implode(', ', $fields);
        $values = implode(', ', $values);

        $sql = "INSERT IGNORE INTO {#}{$table} ({$fields})\nVALUES ({$values})";

        if ($this->db->query($sql)) { return $this->db->lastId(); }

		return false;

	}

		//-----------------------------------------------------------------------------------------------------//
		// ДОБАВЛЕНИЕ КАТЕГОРИЙ ФОРУМА
		//-----------------------------------------------------------------------------------------------------//		
		// Родная функция инстанта
		public function addCatforum($table, $category) {

		$this->db->nestedSets->setTable($table);
		
		$cat_id = $category['id'];
		
		$category['id'] = $this->db->nestedSets->addNode($category['parent_id'], $Order = -1, $Differ = "");

		if (!$category['id']){ echo '<br/> error '.$cat_id.', ', $category['parent_id']; }

		$category['title'] = $this->db->escape($category['title']);

		$this->update($table, $category['id'], $category);

		/* if (empty($category['slug_key'])){
			$category['slug'] = lang_slug($category['title']);
			$category['slug'] = $cat_id . '-' . str_replace('/', '', $category['slug']);
		} else {

			$category['slug'] = $cat_id . '-' . str_replace('/', '', $category['slug_key']);

		} */

		$this->update($table, $category['id'], array(
			'slug' => $category['slug'], 'id' => $cat_id
		));

		cmsCache::getInstance()->clean("forum.categories", "content.categories");

		return $category;

	}
		//-----------------------------------------------------------------------------------------------------//
		// ДОБАВЛЕНИЕ КАТЕГОРИЙ
		//-----------------------------------------------------------------------------------------------------//		
		// Родная функция инстанта	
	    public function addCatmigrate($table_name, $category){

        /* $table_name = $this->table_prefix . $ctype_name . '_cats'; */

        $this->db->nestedSets->setTable($table_name);
		
		$cat_id = $category['id'];

        $category['id'] = $this->db->nestedSets->addNode($category['parent_id']);

       if (!$category['id']){ echo '<br/> Ошибка переноса категории '.$cat_id." родительская каегория  {$category['parent_id']}<br/>"; }

		$category['description'] = isset($category['description']) ?  $category['description'] : NULL;
		
		$category['as_folder'] = isset($category['as_folder']) ?  $category['as_folder'] : NULL;
		
        $this->update($table_name, $category['id'], array(
        'id' => $cat_id
        ));
		
		
        cmsCache::getInstance()->clean("content.categories");

        return $category;

    }
		//-----------------------------------------------------------------------------------------------------//
		// ЗАМЕНА ТЕГОВ В КОНТЕНТЕ
		//-----------------------------------------------------------------------------------------------------//
		
		public function tagsReplace($table = 'users_messages', $column = 'content') {
		
		$this->replace($table, $column, '/upload/', '/upload/old/');
		
		$this->replace($table, $column, '/images/', '/upload/old/');
		
		}
		

	
	}
?>