<?php

class emigrator extends cmsFrontend {

    public function actionFunc() {
		$func = $_POST['type']; // Получаем имя запускаемого файла из аякс-запроса
        $res = $this->model->migrate($func); // Запрос к функции запуска файла миграции (что запускаем)

		// Пытаемся отобразить результат
        $template = cmsTemplate::getInstance();
        return cmsTemplate::getInstance()->render('migrate', array(
        ));
    }
	
	// Функция запуска миграции с циклом на аяксе (для больших таблиц)
	public function actionCycle() {
		if (!isset($_POST['n'])){$_POST['n'] = 0;} // Если нет данных - записываем ноль
		if (!isset($_POST['s'])){$_POST['s'] = 0;} // Если нет данных - записываем ноль
		$func = $_POST['type']; // Получаем имя запускаемого файла из аякс-запроса
		$n = $_POST['n']; // Получаем количество циклов
		$start = $_POST['s']; // Получаем время начала работы скрипта
		
		// Запрос к функции запуска файла миграции (что запускаем, количество циклов, время старта скрипта)
        $res = $this->model->migcycle($func, $n, $start); 
		
        // Пытаемся отобразить результат
        $template = cmsTemplate::getInstance();
        return cmsTemplate::getInstance()->render('migrate', array(
        ));
    }
	
	// Функция формирования файла конфигурации
	public function actionMakeconfig(){
		parse_str($_POST['data'], $data); // Получаем массив с данными от аякса
		$host = $data['host']; // Адрес хоста
		$user = $data['user']; // Имя пользователя базы данных источника
		$pass = $data['pass']; // Пароль пользователя базы данных источника
		$base = $data['base']; // Имя базы данных источника
		$pref = $data['pref']; // Префикс базы данных источника
		//$posts = $data['posts']; // Системное имя типа контента "блоги"
		//$articles = $data['articles']; // Системное имя типа контента "статьи"
		//$news = $data['news']; // Системное имя типа контента "новости"
		//$albums = $data['albums']; // Системное имя типа контента "фотоальбомы"
		//$faq = $data['faq']; // Системное имя типа контента "вопросы и ответы"
		//$board = $data['board']; // Системное имя типа контента "объявления"
		//$catalog = $data['catalog']; // Системное имя типа контента "объявления"
		
		// Вычисляем лимит выборки исходя из выделенной серверу памяти
		$varlimit = intval(@ini_get('memory_limit')*0.015625)*3000; 
		if ($varlimit>10000){$varlimit=10000;} // Чтобы уж совсем много не было
		
		// Проверяем правильность данных для подключения к базе источника
		$link = mysqli_connect($host, $user, $pass, $base ) or die (mysqli_error()); 
		echo 'SUCCESS!!!';
		
		
		
		// Создаем папку в каталоге upload
		mkdir("upload/old", 0777);
		
		// Формируем текст для записи в файл конфигурации
		$conf = "<?php
		\$host = '$host';
		\$user = '$user';
		\$pass = '$pass';
		\$base = '$base';
		\$pref = '$pref';
		\$posts = 'posts';
		\$articles = 'articles';
		\$news = 'news';
		\$albums = 'albums';
		\$faq = 'faq';
		\$board = 'board';
		\$catalog = 'catalog';
		\$varlimit = '$varlimit';
		\$link = mysqli_connect('$host', '$user', '$pass', '$base' ) or die (mysqli_error());
		mysqli_set_charset(\$link, 'utf8');
		?>";
		
		file_put_contents('upload/old/config.php', $conf); // Создаем файл и записываем туда конфиг
		
		if ($this->model->db->getRow('content_types', "name = 'posts'") === NULL) {
		$this->model->db->importDump('system/controllers/emigrator/dumps/dump.sql', $delimiter = ';');} else {echo "posts";}
		
		if ($this->model->db->getRow('content_types', "name = 'catalog'") === NULL) {
		$this->model->db->importDump('system/controllers/emigrator/dumps/catalog.sql', $delimiter = ';');} else {echo "catalog";}
		
		if ($this->model->db->getRow('content_types', "name = 'blogs'") === NULL) {
		$this->model->db->importDump('system/controllers/emigrator/dumps/blogs.sql', $delimiter = ';');} else {echo "blogs";}
		
		if ($this->model->db->getRow('content_types', "name = 'faq'") === NULL) {
		$this->model->db->importDump('system/controllers/emigrator/dumps/faq.sql', $delimiter = ';');} else {echo "faq";}
		
		if ($this->model->db->getRow('controllers', "name = 'forum'") === NULL) {
		$this->model->db->importDump('system/controllers/emigrator/dumps/forum.sql', $delimiter = ';');} else {echo "forum";}
	}
}

?>
