﻿<?php
	
	//-----------------------------------------------------------------------------------------------------//
	// ПЕРЕНОС ОБЪЯВЛЕНИЙ
	//-----------------------------------------------------------------------------------------------------//
	
	$start = microtime(true);
	
	// Очистка таблиц перед миграцией
	$this->db->query("TRUNCATE {#}con_{$board}");
	$this->db->query("TRUNCATE {#}con_{$board}_cats");
	$this->db->query("TRUNCATE {#}con_{$board}_cats_bind");
	
	$this->db->nestedSets->setTable('con_'.$board.'_cats');
	$this->db->nestedSets->addRootNode();
	
	// Получение массива категорий
	$sql = $this->selectold("{$board}_cats", 'id <> 1' );
	
	// Генерация имени контента
	$ctype = array(); $ctype['name']= $board; 
	
	// Генерация массива имен полей контента
	$fields = cmsCore::getModel('content')->getContentFields($board);
	$this->TableName = "{#}$board";
	// Перебор массива данных из исходной таблицы
	foreach ($sql as $res){
		
		// Генерация слага из заголовка
		$category_slug = $res['id'].'-'.lang_slug($res['title']);
		
		// Формирование массива для вставки в новую таблицу
		$parent = array();  
		$parent['parent_id'] = $res['parent_id']; 
		$parent['ordering'] = $res['ordering']; 
		$parent['differ'] = '0';
		$cat = array(
		'id' => $res['id'],
		'parent_id' => $res['parent_id'],
		'title' => $res['title'],
		'description' => $res['description'],
		'slug' => $category_slug,
		'allow_add' => $res['public']
		);	
		
		// Вставка данных в новую таблицу
		$this->addCatmigrate('con_'.$board.'_cats', $cat);
		$this->update('con_'.$board.'_cats', $res['id'], $cat);
		
	}
	
	// Получение массива вопросов и ответов
	$sql = $this->selectold('board_items' );
	
	
	
	// Перебор массива данных полученных из источника
	foreach ($sql as $res){
		
		// Если нет рейтинга - пишем ноль
		if (empty($res['rating'])){$res['rating'] = 0;}
		
		// Генерация слага из заголовка
		$board_slug = $res['id'].'-'.lang_slug($res['title']);
		
		// Генерация массива картинок
		if (!empty($res['file'])){$file = array();
		$file['normal'] = "old/board/medium/".$res['file'];
		$file['small'] = "old/board/small/".$res['file'];
		$res['file'] = cmsModel::arrayToYaml($file);}
		else {$res['file'] = '';}
		
		// Формирование массива для инсерта
		$boards = array(
		'id' => $res['id'],
		'title' => $res['title'],
		'content' => $res['content'],
		'slug' => $board_slug,
		'date_pub' => $res['pubdate'],
		'date_last_modified' => $res['pubdate'],
		'is_pub' => $res['published'],
		'hits_count' => $res['hits'],
		'user_id' => $res['user_id'],
		'category_id' => $res['category_id'],
		'is_comments_on' => '1',
		'rating' => '0',
		'is_approved' => '1',
		'approved_by' => '1',
		'date_approved' => $res['pubdate'],
		'is_private' => $res['is_vip'],
		'photo' => $res['file'],
		'photos' => $res['more_images'],
		'phone' => $res['city'],
		'contacts' => $res['city']
		);
		
		// Вставка данных в новую базу используя родную функцию движка
		cmsCore::getModel('content')->addContentItem($ctype, $boards, $fields);
	}
	
	$this->tagsReplace("con_{$board}"); // Правим тэги в контенте
	
	// Подсчет количества вопросов
	$num = $this->db->getRowsCount("con_{$board}");
	
	echo 'Миграция объявлений завершена. <br/>
	
	Количество записей в таблице con_board =  '.$num;
	
	// Вычисление времени работы скрипта
	$runtime = microtime(true) - $start;
	
	// Отображение времени работы скрипта
	$this->runtime($runtime);
	
	
	
?>