﻿<?php
	
	//-----------------------------------------------------------------------------------------------------//
	// ПЕРЕНОС КАТАЛОГА
	//-----------------------------------------------------------------------------------------------------//	
	
	
	// Время старта скрипта 
	$start = microtime(true);
	
	// Делаем копию типа контента board но с именем catalog
	/* $this->db->importDump('system/controllers/emigrator/dumps/catalog.sql', $delimiter = ';'); */

	
	
	
	//-----------------------------------------------------------------------------------------------------//
	// ПЕРЕНОС каталога
	//-----------------------------------------------------------------------------------------------------//   
	$start = microtime(true);
	
	// Очистка таблиц перед миграцией
	$this->db->query("TRUNCATE {#}con_{$catalog}");
	$this->db->query("TRUNCATE {#}con_{$catalog}_cats");
	$this->db->query("TRUNCATE {#}con_{$catalog}_cats_bind");
	
	$this->db->nestedSets->setTable('con_'.$catalog.'_cats');
	$this->db->nestedSets->addRootNode();
	
	// Получение массива категорий
	$sql = $this->selectold("uc_cats", 'parent_id > 1' );
	
	
	// Генерация имени контента
	$ctype = array(); $ctype['name']= $catalog; 
	
	// Генерация массива имен полей контента
	$fields = cmsCore::getModel('content')->getContentFields($catalog);
	
	// Перебор массива данных из исходной таблицы
	foreach ($sql as $res){
		
		
	if ($res['parent_id'] == '1000'){$res['parent_id'] = 1;}
		
		// Генерация слага из заголовка
		$category_slug = $res['id'].'-'.lang_slug($res['title']);
		
		// Формирование массива для вставки в новую таблицу
		$cat = array(
		'id' => $res['id'],
		'parent_id' => $res['parent_id'],
		'title' => $res['title'],
		'description' => $res['description'],
		'slug' => $category_slug
		);	
		
		// Вставка данных в новую таблицу
		$this->addCatmigrate('con_'.$catalog.'_cats', $cat);
		$this->update('con_'.$catalog.'_cats', $res['id'], $cat);
	}
	
	// Получение массива вопросов и ответов
	$sql = $this->selectold('uc_items' );
	
	
	
	// Перебор массива данных полученных из источника
	foreach ($sql as $res){
		
		// Если нет рейтинга - пишем ноль
		if (empty($res['rating'])){$res['rating'] = 0;}
		
		// Генерация слага из заголовка
		$catalog_slug = $res['id'].'-'.lang_slug($res['title']);
		
		// Генерация массива картинок
		if (!empty($res['file'])){$file = array();
			$file['normal'] = "old/board/medium/".$res['imageurl'];
			$file['small'] = "old/board/small/".$res['imageurl'];
		$res['imageurl'] = cmsModel::arrayToYaml($file);}
		else {$res['imageurl'] = '';}
		
		// Формирование массива для инсерта
		$catalogs = array(
		'id' => $res['id'],
		'title' => $res['title'],
		'content' => $res['title'],
		'slug' => $catalog_slug,
		'seo_keys' => $res['meta_keys'],
		'seo_desc' => $res['meta_desc'],
		'seo_title' => $res['title'],
		'tags' => $res['tags'],
		'date_pub' => $res['pubdate'],
		'is_pub' => $res['published'],
		'hits_count' => $res['hits'],
		'user_id' => $res['user_id'],
		'category_id' => $res['category_id'],
		'is_comments_on' => $res['is_comments'],
		'rating' => $res['rating'],
		'is_approved' => $res['published'],
		'approved_by' => '1',
		'photo' => $res['imageurl'],
		'price' => $res['price']
		);
		
		// Вставка данных в новую базу используя родную функцию движка
		cmsCore::getModel('content')->addContentItem($ctype, $catalogs, $fields);
	}
	
	$this->tagsReplace("con_{$catalog}"); // Правим тэги в контенте
	
	// Подсчет количества вопросов
	$num = $this->db->getRowsCount("con_{$catalog}");
	
	echo 'Миграция объявлений завершена. <br/>
	
	Количество записей в таблице con_board =  '.$num;
	
	// Вычисление времени работы скрипта
	$runtime = microtime(true) - $start;
	
	// Отображение времени работы скрипта
	$this->runtime($runtime);
	
?>