﻿<?php
	
	//-----------------------------------------------------------------------------------------------------//
	// ПЕРЕНОС map 
	//-----------------------------------------------------------------------------------------------------//
	
	
	$start = microtime(true);
	echo "Таблица источника - con_places ";
	$this->db->query('TRUNCATE {#}con_places_cats');
	$this->db->query('TRUNCATE {#}con_places');
	$this->db->query('TRUNCATE {#}places_markers');
	$this->db->query('TRUNCATE {#}con_places_cats_bind');
	
	$sql = $this->selectold('map_cats');
	foreach ($sql as $res){
		$mapcat = array(
		'id' => $res['id'],
		'parent_id' => $res['parent_id'],
		'title' => $res['title'],
		'slug' => $res['seolink'],
		'ordering' => $res['ordering'],
		'ns_left' => '1',
		'ns_right' => '1',
		'ns_level' => '1',
		'ns_differ' => '0',
		'ns_ignore' => '0',
		'is_events' => '1',
		'is_reviews' => '1'
		);
		$this->insert('con_places_cats', $mapcat);
	}
	
	//  //привязка объектов к категориям  
	$sql = $this->selectold('map_items');
	foreach ($sql as $res){
		$bind = array(
		'item_id' => $res['id'],
        'category_id' => $res['category_id']
		);
		$this->insert('con_places_cats_bind', $bind);
	}
	
	
	//markers
	echo "<br/>Таблица источника - con_places_markers";
	
	$sql = $this->selectold('map_markers');
	foreach($sql as $res){
		$res['addr_street'] = $res['addr_prefix'].'.'.$res['addr_street'];
		$contacts = array();
		$contacts['phone'] = $res['addr_phone'];
		$res['contacts'] = cmsModel::arrayToYaml($contacts);
		$marker = array(
		'id' => $res['id'],
		'item_id' => $res['item_id'],
		'addr_country' => $res['addr_country'],
		'addr_city_id' => $res['city_id'],
		'addr_city' => $res['addr_city'],
		'addr_street' => $res['addr_street'],
		'addr_house' => $res['addr_house'],
		'addr_room' => $res['addr_room'],
		'addr_hash' => $res['addr_hash'],
		'lat' => $res['lat'],
		'lng' => $res['lng'],
		'contacts' => $res['contacts']
		);
		$this->insert('places_markers', $marker);
	}
	//карточка объекта
	
	$sql = $this->selectold('map_items');
	foreach($sql as $res){
		$photo = array();
		$photo['big'] = 'old/photos/map'. $res['id'].'.jpg';
		$photo['normal'] = 'old/photos/medium/map'. $res['id'].'.jpg';
		$photo['small'] = 'old/photos/small/map'. $res['id'].'.jpg';
		$res['photo'] = cmsModel::arrayToYaml($photo);
		$phone = cmsModel::yamlToArray($res['contacts']);
		$res['phone'] = $phone['phone'];
		$res['url'] = $phone['url'];
		$res['email'] = $phone['email'];
		$places = array(
		'id' => $res['id'],
		'title' => $res['title'],
		'content' => $res['description'],
		'photo' => $res['photo'],
		'slug' => $res['seolink'],
		'seo_keys' => $res['metakeys'],
		'seo_desc' => $res['metadesc'],
		'tags' => $res['metakeys'],
		'date_pub' => $res['pubdate'],
		'date_last_modified' => $res['pubdate'],
		'date_pub_end' => '0',
		'is_pub' => $res['published'],
		'hits_count' => $res['hits'],
		'user_id' => $res['user_id'],
		'category_id' => $res['category_id'],
		'is_comments_on' => '1',
		'rating' => $res['rating'],
		'rating_avg' => $res['rating'],
		'is_approved' => '1',
		'approved_by' => '1',
		'date_approved' => $res['pubdate'],
		'is_private' => '0',
		'photos' => $res['img_count'],
		'phone' => $res['phone'],
		'url' => $res['url'],
		'email' => $res['email'],
		'teaser' => $res['metadesc']
		);
		$this->insert('con_places', $places);
	}
	/* echo "Таблица источника - con_places";
		$this->db->query("INSERT IGNORE INTO $imem (
		`id`, `title`, `content`, `photo`, `slug`, `seo_keys`, `seo_desc`, `tags`, `date_pub`, `date_last_modified`, `is_pub`, `hits_count`, `user_id`, `category_id`, `is_comments_on`, `rating`, `rating1`, `rating2`, `rating3`, `rating_avg`, `is_approved`, `approved_by`, `date_approved`, `is_private`, `teaser`
		)
		SELECT `id`, `title`, `description`, 
		CONCAT('---
		big: photos/map', id,'.jpg','
		', 'normal: photos/medium/map', id,'.jpg','
		', 'small: photos/small/map', id,'.jpg'), `seolink`, `metakeys`, `metadesc`, `metakeys`, `pubdate`, `pubdate`, `published`, `hits`, `user_id`, `category_id`, 1, `rating`, `rating`, `rating`, `rating`, `rating`, 1, 1, `pubdate`, 0, `shortdesc`
	FROM $map "); */
	
	// $this->db->query("INSERT IGNORE INTO cms_con_places (
	//        item_id, category_id) SELECT id, category_id FROM {#}con_$maps
	//        WHERE id=item_id" );
	$num = $this->db->getRowsCount('places_markers');
	echo '<br/>Миграция карт завершена. 
	<br/>Количество маркеров в таблице  =  '.$num;
	$runtime = microtime(true) - $start;
	$this->runtime($runtime);
	
	?>	