﻿<?php
	
	//-----------------------------------------------------------------------------------------------------//
	// ПЕРЕНОС НОВОСТЕЙ
	//-----------------------------------------------------------------------------------------------------//
	
	$start = microtime(true);
	
	echo "Таблица источника - {$pref}content ";
	
	$this->db->query('TRUNCATE {#}con_'.$news.'_cats_bind');
	
	$this->db->query('TRUNCATE {#}con_'.$news.'_cats');
	
	$this->db->query('TRUNCATE {#}con_'.$news.'');
	
	$this->db->nestedSets->setTable('con_'.$news.'_cats');
	$this->db->nestedSets->addRootNode();
	
	// Формируем массив имени типа контента для функции вставки 
	$ctype = array(); $ctype['name']= $news; 
	
	// Формируем массив полей для функции вставки 
	$fields = cmsCore::getModel('content')->getContentFields($news);
	
	$sql = $this->selectold('content', 'category_id = 2 ' );
	
	foreach ($sql as $res){
		
		if (empty($res['meta_keys'])){$res['meta_keys'] = 0;}
		
		if (empty($res['meta_desc'])){$res['meta_desc'] = 0;}
		
		$res['rating'] = isset($res['rating']) ? $res['rating'] : 0; // Если нет данных - записываем ноль
		
		// Формируем слаг статьи из заголовка
		$news_slug = $res['id'].'-'.lang_slug($res['title']);
		
		$new = array(
		
		'id' => $res['id'], 
		'title' => $res['title'], 
		'content' => $res['content'], 
		'slug' => $news_slug, 
		'seo_keys' => $res['meta_keys'],
		'seo_desc' => $res['meta_desc'], 
		'seo_title' => $res['title'],
		'date_pub' => $res['pubdate'], 
		'is_pub' => '1', 
		'hits_count' => $res['hits'], 
		'user_id' => $res['user_id'],
		'parent_url' => $res['seolink'], 
		'parent_url' => $res['url'],
		'category_id' => 'NULL',
		'is_comments_on' => $res['comments'], 
		'rating' => $res['rating'], 
		'is_approved' => '1' 
		);	
		
		cmsCore::getModel('content')->addContentItem($ctype, $new, $fields); 
	}
	
	$this->db->query("UPDATE {#}con_$news SET slug = REPLACE(slug, 'news', '')");
	
	$this->db->query("INSERT IGNORE INTO {#}con_news_cats_bind 
	(item_id, category_id) SELECT id, category_id FROM {#}con_$news");
	
	$num = $this->db->getRowsCount('con_'.$news.'');
	
	echo '<br/>Миграция новостей завершена. <br/>
	
	Количество записей в таблице con_news =  '.$num.'. ';
	
	$end = microtime(true);
	
	$runtime = $end - $start;
	
	$this->runtime($runtime);
	
	
?>