﻿<?php
	
	// Получаем номера типов контента блогов и постов
	$parent_ctype = ($this->db->getRow('content_types', "name = 'blogs'"));
	$parent_ctype_id = $parent_ctype['id'];
	$child_ctype = ($this->db->getRow('content_types', "name = 'posts'"));
	$child_ctype_id = $child_ctype['id'];
	
	$lim = $n * $varlimit; // Вычисление лимита выборки строк для цикла
	
	$limit = "LIMIT {$lim}, {$varlimit}"; // Формирование подзапроса лимита
	
	echo $limit, "<br/>";
	
	$bldon = $this->selectold('blog_posts', '1', $limit); // Выборка из таблицы источника с условиями
	
	$ctype = array(); $ctype['name']='posts'; // Формирование переменной для функции добавления контента
	
	$fields = cmsCore::getModel('content')->getContentFields('posts'); // Формирование переменной для функции добавления контента
	
	// Перебор массива полученных из источника данных
	foreach ($bldon as $res){
		
		$post_slug = $res['id'].'-'.lang_slug($res['title']); // Генерация слага
		
		$res['meta_keys'] =  isset($res['meta_keys']) ? $res['meta_keys'] : 0; // Если нет данных - записываем ноль
		
		$res['meta_desc'] = isset($res['meta_desc']) ? $res['meta_desc'] : 0; // Если нет данных - записываем ноль
		
		$res['rating'] = isset($res['rating']) ? $res['rating'] : 0; // Если нет данных - записываем ноль
		
		$res['hits'] = isset($res['hits']) ? $res['hits'] : $res['hits'] = isset($res['hint']) ? $res['hint'] : 0; // Если нет данных - записываем ноль
		
		
		$res['comments_count'] = isset($res['comments_count']) ? $res['comments_count'] : 0; // Если нет данных - записываем ноль
		
		// Получаем номера блогов  которыми связаны посты
		$parent_type = $this->selectold('blogs', "id = {$res['blog_id']}", 'LIMIT  1');
		
		if ($parent_type[0]['owner'] == 'club'){
			$parent_id = $parent_type[0]['user_id'];
			$parent_title = $parent_type[0]['title'];
			$parent_url = 'groups/'.$parent_type[0]['user_id']."/content/$posts";
			$p_type = 'group';
			} else {
			$relation = array(
			'parent_ctype_id' => $parent_ctype_id,
			'parent_item_id' => $res['blog_id'],
			'child_ctype_id' => $child_ctype_id,
			'child_item_id' => $res['id']
			);
			
			// Вставка в таблицу связей
			$this->db->insert('content_relations_bind', $relation);
			
			$p_type = NULL;
			$parent_id = NULL;
			$parent_title = NULL;
			$parent_url = NULL;
			} 
		
		// Формирование массива для функции добавления контента
		$toBl = array(
		'id' => $res['id'],
		'title' => $res['title'],
		'slug' => $post_slug,
		'content' => $res['content_html'],
		'seo_keys' => $res['meta_keys'],
		'seo_desc' => $res['meta_desc'],
		'seo_title' => $res['title'],
		'tags' => $res['meta_desc'],
		'date_pub' => $res['pubdate'],
		'date_last_modified' => $res['edit_date'],
		'is_pub' => $res['published'],
		'hits_count' => $res['hits'],
		'user_id' => $res['user_id'],
		'parent_type' => $p_type,
		'parent_id' => $parent_id,
		'parent_title' => $parent_title,
		'parent_url' => $parent_url,
		'parent_blogs_id' => $res['blog_id'],
		'category_id' => $res['cat_id'],
		'is_comments_on' => '1',
		'rating' => $res['rating'],
		'is_approved' => '1'
		);
		
		// Добавления контента используя родную функцию INSTANTCMS
		cmsCore::getModel('content')->addContentItem($ctype, $toBl, $fields); 
		
	} 
	
	// Получение количества строк в конечной таблице после миграции
	$num = $this->db->getRowsCount('users_messages');
	
	echo 'Миграция блогов в процессе. <br/>
	
	Количество записей в таблице con_posts =  '.$num.'. <br/>';
	
	$end = microtime(true); // Вычисление времени окончания работы скрипта
	
	$runtime = $end - $start; // Вычисление времени работы скрипта
	
	$this->runtime($runtime); // Отображение времени работы скрипта
	
	
?>	