﻿<?php
	
	//-----------------------------------------------------------------------------------------------------//
	// ПЕРЕНОС ФОТОАЛЬБОМОВ ПОЛЬЗОВАТЕЛЕЙ
	//-----------------------------------------------------------------------------------------------------//   
	
	$start = microtime(true);   
	echo "Таблица источника - {$pref}user_photos  ";
	
	$sql = $this->selectold('user_albums');
	
	foreach($sql as $res){
		
		$album_slug = $res['id'].'-'.lang_slug($res['title']);
		
		$counter = $this->counter('user_photos', "album_id = {$res['id']}");
		
		$cover_sql = $this->selectold('user_photos', "album_id = {$res['id']}", 'ORDER BY id DESC LIMIT 1' );
		$cover = "---
		original: old/users/photos/medium/{$cover_sql[0]['imageurl']}
		big: old/users/photos/medium/{$cover_sql[0]['imageurl']}
		normal: old/users/photos/medium/{$cover_sql[0]['imageurl']}
		small: old/users/photos/small/{$cover_sql[0]['imageurl']}";
		
		$album = array(
		'id' => $res['id'],
		'title' => $res['title'],
		'content' => $res['description'],
		'slug' => $album_slug,
		'date_pub' => $res['pubdate'],
		'date_last_modified' => $res['pubdate'] ?: NULL,
		'is_pub' => 1,
		'user_id' => $res['user_id'],
		'category_id' => '1',
		'cover_image' => $cover,
		'is_comments_on' => 1,
		'photos_count' => $counter,
		'is_approved' => '1',
		'is_public' => '1'
		);
		
		$this->insertignore('con_albums', $album);
	}
	
	$sql = $this->selectold('user_photos');
	
	foreach($sql as $res){
		
		$photo_slug = $res['id'].'-'.lang_slug($res['title']);
		
		if ($res['imageurl']) {
			
			$photofile = array();
			$photofile['original'] = 'old/users/photos/medium/' . $res['imageurl'];
			$photofile['big'] = 'old/users/photos/medium/' . $res['imageurl'];
			$photofile['normal'] = 'old/users/photos/medium/' . $res['imageurl'];
			$photofile['small'] = 'old/users/photos/small/' . $res['imageurl'];
			$res['file'] = cmsModel::arrayToYaml($photofile);
			} else {
			
			$res['file'] = '';
		}
		
		if (empty($res['rating'])){$res['rating'] = 0;}
		
		$photos = array(
		/* 'id' => $res['id'], */
		'album_id' => $res['album_id'],
		'user_id' => $res['user_id'],
		'date_pub' => $res['pubdate'],
		'date_photo' => $res['pubdate'],
		'title' => $res['title'],
		'sizes' => '---
original:
  width: 500
  height: 500
big:
  width: 500
  height: 500
normal:
  width: 250
  height: 250
small:
  width: 64
  height: 64',
		'image' => $res['file'],
		'rating' => $res['rating'],
		'hits_count' => $res['hits'],
		'slug' => $photo_slug
		);
		
		$this->db->insert('photos', $photos);
	}
	
	$num = $this->db->getRowsCount('photos');
	
	echo '<br/>Миграция альбомов и фото завершена.<br/>
	
	Количество записей в таблице photos =  '.$num;
	
	$runtime = microtime(true) - $start;
	
$this->runtime($runtime);       


?>