﻿<?php
	
	//-----------------------------------------------------------------------------------------------------//
	// ПЕРЕНОС ПОЛЬЗОВАТЕЛЕЙ
	//-----------------------------------------------------------------------------------------------------//   
	
	$start = microtime(true); // Получаем время старта скрипта
	
	echo "Таблица источника - {$pref}users.  ";
	
	$this->db->query( 'delete from {#}users where id>1');  // Очищаем таблицу перед миграцией
    $this->db->query('delete from {#}users_groups_members where user_id>1'); // Очищаем таблицу перед миграцией
	
	
	// Если на сайте источника есть компонент географии - присоединяем определение города
	if (mysqli_query($link, "SELECT * FROM {$pref}geo_cities"))
	{$join = "left join  {$pref}geo_cities g on g.name = p.city
	left join  {$pref}geo_cities d on d.id = g.id"; $gid = 'g.id as cityid, d.name as cityname,';}
	else {$join = ''; $gid ='p.city as cityname, 0 as cityid,';} // Если нет компонента географии - пишем нули
	// Это для работы под Mysql-5.7
	$sql= "
	SET SESSION sql_mode=(SELECT REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY',''))";
	$sess = mysqli_query($link, $sql) or die (mysqli_error($link));
	
	// Выборка из всех таблиц имеющих отношение к юзерам
	$sql= "
	SELECT DISTINCT u.id, u.email, u.login, u.password, u.nickname, u.regdate, u.logdate, u.last_ip, u.is_locked,
	u.rating, u.birthdate
	, {$gid}  p.description, p.karma, p.imageurl , p.gender, p.formsdata
	FROM {$pref}users u 
	left join {$pref}user_profiles p on u.id=p.user_id
		{$join}
	where u.id <> '1' AND  u.is_deleted < 1 GROUP BY u.id
	ORDER BY u.email, u.logdate desc, u.regdate asc, u.id asc 
	";
	
	$source = mysqli_query($link, $sql) or die (mysqli_error($link)); // Запуск этой выборки
	
	$lastemail = ''; // Последний емейл. Тот, что висит в кэше
	
	$numemail = 0; // Счетчик одинаковых емейлов
	
	// Перебор полученных из таблицы данных и формирование значений для записи в новую базу
	while ($row = mysqli_fetch_assoc($source)) {
		$row['signature_html'] = "";
		
		// Если нет даты последнего визита - пишем новый 2013 год
		if ($row['logdate'] == '0000-00-00 00:00:00') {
			$row['logdate'] = '2013-01-01 00:00:00';
		}
		// Если нет даты регистрации - пишем новый 2011 год
		if ($row['regdate'] == '0000-00-00 00:00:00') {
			$row['regdate'] = '2011-01-01 00:00:00';
		}
		// если между емейлом в кэше и емейлом из базы нет разницы
		// - приписываем в начало какой повторный емейл по счету умножить на 1111
		if (strcasecmp($lastemail, $row['email']) == 0) {
			$numemail++;
			$row['email']=($numemail*1111). ($row['email']);
			} else {
			$lastemail = $row['email'];
			$numemail = 0;
		}
		// Если у юзера есть аватар - 
		// формируем массив с адресами разных размеров аватара
		if ($row['imageurl']) {
			
			$avatar = array();
			$avatar['micro'] = 'old/users/avatars/small/' . $row['imageurl'];
			$avatar['small'] = 'old/users/avatars/small/' . $row['imageurl'];
			$avatar['normal'] = 'old/users/avatars/' . $row['imageurl'];
			$row['avatar'] = cmsModel::arrayToYaml($avatar);
			} else {
			$row['avatar'] = ''; // Если нет аватара - значит нет...
		}
		// Генерация статусов и подписей
		if (!empty($row['signature_html'])) {
			$row['status_id'] = 1;
			$row['status_text'] = $row['signature_html'];
			} else {
			$row['status_id'] = '';
			$row['status_text'] = $row['signature_html'];
		}
		
		/* if (!$row['description']) {$row['description'] = addslashes($row['signature_html']);}
		else {$row['description'] = addslashes($row['description']);}
		
		$row['nickname'] = addslashes($row['nickname']); */
		
		$row['time_zone'] = 'Europe/Moscow'; // Если Вы смогли выбраться из Москвы - отредактируйте эту строку.
		
		$row['friends_count'] = $this->getfriendscount($row['id']); // Подсчет друзей
		
		// Генерация соли и хэша пароля.    
		$pass = $this->db->escape($row['password']);
		
		$password_salt = md5(implode(':', array($pass, session_id(), time(), rand(0, 10000))));
		
		$password_salt = substr($password_salt, rand(1, 8), 16);
		
		$pass_hash = MD5(($this->db->escape($row['password']) . $password_salt));
		
		// id пользоавтеля определяем отдельно, чтобы не сбилась их нумерация на сайте. 
		$id = $this->db->escape($row['id']);
		
		if (empty($row['karma'])){$row['karma'] = 0;}
		
		if (empty($row['nickname'])){$row['nickname'] = $row['login'];}	
		
		$group = array('4');
		$groups = cmsModel::arrayToYaml($group); // Массив групп пользователей. Всех в группу 4 (пользователи)
		// Массив для вставки в таблицу пользователей
		$us = array(
		'id' => $id,
		'groups' => $groups,
		'email' => $row['email'],
		'password' => $pass_hash,
		'password_salt' => $password_salt,
		'nickname' => $row['nickname'],
		'date_reg' => $row['regdate'],
		'date_log' => $row['logdate'],
		'ip' => $row['last_ip'],
		'is_locked' => $row['is_locked'],
		'rating' => $row['rating'],
		'birth_date' => $row['birthdate'],
		'hobby' => $row['description'],
		'avatar' => $row['avatar'],
		'karma' => $row['karma'],
		'status_id' => $row['status_id'],
		'status_text' => $row['status_text'],
		'city' => $row['cityid'],
		'city_cache' => $row['cityname'],
		'friends_count' => $row['friends_count'],
		'time_zone' => $row['time_zone']
		);	
	
		$this->insertignore('{users}', $us); // Вставляем данные в новую таблицу
		
		// прописываем всех пользователей в группу "пользователи"
		$this->db->insert('{users}_groups_members', array(
                'user_id' => $id,
                'group_id' => '4'
            ));
	}
	

	
	$num = $this->db->getRowsCount('users'); // Подсчитываем число перенесенных юзеров
	
	echo '<br/>Миграция пользователей завершена. <br/>
	
	Количество записей в таблице users =  '.$num;
	
	$runtime = microtime(true) - $start; // Вычисляем время выполнения скрипта
	
	$this->runtime($runtime); // Отображаем время выполнения скрипта
	
	
?>